@using LSerialObserver.Domain.Parser

<EditForm EditContext="@_editContext">
  <label class="form-label fw-bold">Package Lenght</label>
  <div class="input-group mb-3" style="width: 150px;">
    <InputNumber type="number" @bind-Value="_options.Length" min="0" class="form-control"/>
    <span class="input-group-text">bits</span>
  </div>

  <label class="form-label fw-bold">Endianness</label>
  <div class="mb-3">
    <InputSelect @bind-Value="_options.Endianness" class="form-control">
      <option value="@FixedBinaryOptions.EndiannessType.Little">Little-endian</option>
      <option value="@FixedBinaryOptions.EndiannessType.Big">Big-endian</option>
    </InputSelect>
  </div>

  <table class="table table-bordered border-secondary">
    <thead>
    <tr>
      <th scope="col">№</th>
      <th scope="col">Name</th>
      <th scope="col">Position</th>
      <th scope="col">Lenght</th>
      <th scope="col">Type</th>
      <th scope="col"></th>
    </tr>
    </thead>
    <tbody>
    @foreach (var (index, field)  in _options.Fields.Select((member, i) => (i, member)))
    {
      <tr>
        <td>
          <input type="text" value="@index" class="form-control" disabled style="width: 50px;">
        </td>
        <td>
          <InputText type="text" @bind-Value="field.Name" class="form-control"/>
        </td>
        <td>
          <InputNumber type="number" @bind-Value="field.Position" min="0" class="form-control" style="width: 80px;"/>
        </td>
        <td>
          <InputNumber type="number" @bind-Value="field.Length" min="0" class="form-control" style="width: 80px;"/>
        </td>
        <td>
          <select class="form-select" disabled>
            <option>Integer</option>
          </select>
        </td>
        <td>
          <button @onclick="() => RemoveParserField(index)" class="btn btn-outline-danger">
            <i class="bi bi-trash"></i>
          </button>
        </td>
      </tr>
    }
    </tbody>
  </table>

  <button @onclick="AddNewParserField" class="btn btn-outline-primary">
    <i class="bi bi-plus"></i>
    Add Field
  </button>
</EditForm>

@code {

  private EditContext _editContext;
  private FixedBinaryOptions _options;

  [Parameter]
  public FixedBinaryOptions Options { get; set; }

  [Parameter]
  public EventCallback<FixedBinaryOptions> OptionsChanged { get; set; }

  protected override void OnInitialized()
  {
    _options = Options ?? new FixedBinaryOptions();
    _editContext = new EditContext(_options);
    _editContext.OnFieldChanged +=
      (_, _) => OptionsChanged.InvokeAsync(IsValid() ? _options : null);
  }

  private bool IsValid()
  {
    return true;
  }

  private void AddNewParserField()
  {
    _options.Fields.Add(new FixedBinaryOptions.Field());
  }

  private void RemoveParserField(int index)
  {
    _options.Fields.RemoveAt(index);
  }

  protected override Task OnInitializedAsync()
  {
  // Default parser options
    _options = Options ?? new FixedBinaryOptions
    {
      Length = 32,
      Endianness = FixedBinaryOptions.EndiannessType.Little,
      Fields = new List<FixedBinaryOptions.Field>
      {
        new()
        {
          Name = "Temp",
          Position = 0,
          Length = 32
        }
      }
    };

    return base.OnInitializedAsync();
  }

}
